Index: FL/Fl_Tabs.H
===================================================================
--- FL/Fl_Tabs.H	(revision 6732)
+++ FL/Fl_Tabs.H	(working copy)
@@ -77,6 +77,32 @@
   int push(Fl_Widget *);
   Fl_Tabs(int,int,int,int,const char * = 0);
   Fl_Widget *which(int event_x, int event_y);
+
+#ifdef FL_HAVE_MSAA
+  // MSAA support
+  friend class Fl_Msaa_Tabs_Proxy;
+
+private:
+  Fl_Msaa_Tabs_Proxy* msaa_tabs_proxy_;
+  void msaa_tabs_on_focus(long id);
+
+protected:
+  void msaa_cleanup();
+  long msaa_child_count()  {return children() + 1;}
+  Fl_Msaa_Proxy* msaa_child(long id);
+  long msaa_child_id(Fl_Widget* o) const;
+  Fl_Widget* msaa_child_widget(long id) const;
+
+  long msaa_tabs_selected_id();
+  bool msaa_tabs_name(long id, BSTR* bstr);
+  long msaa_tabs_state(long id);
+  bool msaa_tabs_shortcut(long id, BSTR* bstr);
+  bool msaa_tabs_help(long id, BSTR* bstr);
+  bool msaa_tabs_location(long id, long* X, long* Y, long* W, long* H);
+
+public:
+  void msaa_on_focus();
+#endif // FL_HAVE_MSAA
 };
 
 #endif
Index: FL/Fl_Group.H
===================================================================
--- FL/Fl_Group.H	(revision 6732)
+++ FL/Fl_Group.H	(working copy)
@@ -192,6 +192,33 @@
 
   /** This is for forms compatibility only */
   void forms_end();
+
+#ifdef FL_HAVE_MSAA
+  // MSAA support
+protected:
+  bool msaa_focusable()  {return false;}
+  long msaa_child_count()  {return children();}
+  Fl_Msaa_Proxy* msaa_child(long id);
+  bool msaa_name(long id, BSTR* bstr);
+  bool msaa_value(long id, BSTR* bstr);
+  bool msaa_description(long id, BSTR* bstr);
+  long msaa_role(long id);
+  long msaa_state(long id);
+  bool msaa_help(long id, BSTR* bstr);
+  bool msaa_help_topic(long id, BSTR* bstr, long* num);
+  bool msaa_shortcut(long id, BSTR* bstr);
+  long msaa_focus();
+  bool msaa_action(long id, BSTR* bstr);
+  bool msaa_do_select(long id, long flags);
+  bool msaa_location(long id, long* X, long* Y, long* W, long* H);
+  bool msaa_do_action(long id);
+  bool msaa_put_value(long id, const char* str);
+
+  virtual Fl_Widget* msaa_child_widget(long id) const;
+
+public:
+  long msaa_child_id(Fl_Widget*) const;
+#endif // FL_HAVE_MSAA
 };
 
 // dummy class used to end child groups in constructors for complex
Index: FL/Fl_Slider.H
===================================================================
--- FL/Fl_Slider.H	(revision 6732)
+++ FL/Fl_Slider.H	(working copy)
@@ -111,6 +111,21 @@
 
   /** Sets the slider box type. */
   void slider(Fl_Boxtype c) {slider_ = c;}
+
+#ifdef FL_HAVE_MSAA
+  // MSAA support
+protected:
+  void msaa_valuator_on_change();
+  bool msaa_slider_location(long id,
+    long oX, long oY, long oW, long oH, long* X, long* Y, long* W, long* H);
+  long msaa_child_count()  {return 3;}
+  bool msaa_name(long id, BSTR* bstr);
+  long msaa_role(long id);
+  long msaa_state(long id);
+  bool msaa_action(long id, BSTR* bstr);
+  bool msaa_location(long id, long* X, long* Y, long* W, long* H);
+  bool msaa_do_action(long id);
+#endif // FL_HAVE_MSAA
 };
 
 #endif
Index: FL/Fl_Browser_.H
===================================================================
--- FL/Fl_Browser_.H	(revision 6732)
+++ FL/Fl_Browser_.H	(working copy)
@@ -323,6 +323,41 @@
   */
   void scrollbar_left() { scrollbar.align(FL_ALIGN_LEFT); }
   void sort(int flags=0);
+#ifdef FL_HAVE_MSAA
+  // MSAA support
+  friend class Fl_Msaa_Browser_Proxy;
+
+private:
+  Fl_Msaa_Browser_Proxy* msaa_browser_proxy_;
+
+protected:
+  void msaa_cleanup();
+  bool msaa_focusable()  {return true;}
+  long msaa_child_count()  {return 4;}
+  Fl_Msaa_Proxy* msaa_child(long id);
+  long msaa_role(long id);
+  long msaa_state(long id);
+  long msaa_focus();
+  bool msaa_location(long id, long* X, long* Y, long* W, long* H);
+  Fl_Widget* msaa_child_widget(long id) const;
+
+  virtual void msaa_browser_bbox(long* X, long* Y, long* W, long* H);
+  virtual bool msaa_browser_item_bbox(long childId,
+    long* X, long* Y, long* W, long* H);
+  virtual long msaa_browser_size();
+  virtual bool msaa_browser_displayed(long id);
+  virtual bool msaa_browser_selected(long id);
+  virtual long msaa_browser_find_item(void* l);
+  virtual long msaa_browser_focus();
+  virtual void msaa_browser_set_focus(long id);
+  virtual bool msaa_browser_text(long id, BSTR* bstr)  {return false;}
+  virtual bool msaa_browser_description(long id, BSTR* bstr)  {return false;}
+  virtual bool msaa_browser_do_select(long id, long flags);
+
+public:
+  long msaa_child_id(Fl_Widget* o) const;
+  void msaa_on_focus();
+#endif // FL_HAVE_MSAA
 };
 
 #endif
Index: FL/Fl_Export.H
===================================================================
--- FL/Fl_Export.H	(revision 6732)
+++ FL/Fl_Export.H	(working copy)
@@ -29,6 +29,15 @@
 #  define Fl_Export_H
 
 /*
+ * Set WINVER before it gets defined in winver.h
+ */
+
+#  if !defined(WINVER) && defined(__MINGW32__)
+#    define WINVER 0x0500
+#  endif
+
+
+/*
  * The following is only used when building DLLs under WIN32...
  */
 
Index: FL/Fl_Menu_Item.H
===================================================================
--- FL/Fl_Menu_Item.H	(revision 6732)
+++ FL/Fl_Menu_Item.H	(working copy)
@@ -394,6 +394,14 @@
     return add(a,fl_old_shortcut(b),c,d,e);}
 
   int size() const ;
+
+#ifdef FL_HAVE_MSAA
+  // MSAA support
+  bool msaa_name(BSTR* bstr) const;
+  bool msaa_value(BSTR* bstr) const;
+  bool msaa_shortcut(bool on_menubar_, BSTR* bstr) const;
+  bool msaa_put_value(const char* str);
+#endif // FL_HAVE_MSAA
 };
 
 typedef Fl_Menu_Item Fl_Menu; // back compatibility
Index: FL/Fl_Widget.H
===================================================================
--- FL/Fl_Widget.H	(revision 6732)
+++ FL/Fl_Widget.H	(working copy)
@@ -33,6 +33,12 @@
 
 #include "Enumerations.H"
 
+#if defined(WIN32) && (!defined(__GNUC__) || __GNUC__ >= 3)
+#  define FL_HAVE_MSAA
+#  include <ole2.h>
+class Fl_Msaa_Proxy;
+#endif
+
 class Fl_Widget;
 class Fl_Window;
 class Fl_Group;
@@ -911,6 +917,51 @@
       \deprecated Use selection_color(unsigned) instead.
   */
   void color2(unsigned a) {color2_ = a;}
+
+#ifdef FL_HAVE_MSAA
+  // MSAA support
+  friend class Fl_Msaa_Proxy;
+
+protected:
+  Fl_Msaa_Proxy* msaa_proxy_;
+
+  bool msaa_visible() const  {return visible_r() && (w() > 0) && (h() > 0);}
+  void msaa_show_caret(long X, long Y, long W, long H);
+  void msaa_hide_caret();
+  static void msaa_convert_selection(long* ids, size_t count, VARIANT* pvar);
+
+  virtual bool msaa_use_proxy()  {return true;}
+  virtual bool msaa_focusable()  {return handle(FL_FOCUS);}
+  virtual void msaa_cleanup();
+  virtual const Fl_Window* msaa_window() const  {return window();}
+  virtual long msaa_child_count()  {return 0;}
+  virtual bool msaa_parent(IDispatch** dispatch);
+  virtual Fl_Msaa_Proxy* msaa_child(long id);
+  virtual Fl_Msaa_Proxy* msaa_as_parent()  {return msaa_child(0);}
+  virtual long msaa_child_id(Fl_Widget* o) const  {return -1;}
+  virtual bool msaa_name(long id, BSTR* bstr);
+  virtual bool msaa_value(long id, BSTR* bstr)  {return false;}
+  virtual bool msaa_description(long id, BSTR* bstr)  {return false;}
+  virtual long msaa_role(long id);
+  virtual long msaa_state(long id);
+  virtual bool msaa_help(long id, BSTR* bstr);
+  virtual bool msaa_help_topic(long id, BSTR* bstr, long* num)  {return false;}
+  virtual bool msaa_shortcut(long id, BSTR* bstr);
+  virtual long msaa_focus();
+  virtual bool msaa_selection(VARIANT* variant)  {return false;}
+  virtual bool msaa_action(long id, BSTR* bstr)  {return false;}
+  virtual bool msaa_do_select(long id, long flags);
+  virtual bool msaa_location(long id, long* X, long* Y, long* W, long* H);
+  virtual long msaa_navigate(long id, long dir);
+  virtual bool msaa_do_action(long id)  {return false;}
+  virtual bool msaa_put_value(long id, const char* str)  {return false;}
+
+public:
+  void msaa_notify(DWORD event, long childId = 0);
+
+  virtual Fl_Msaa_Proxy* msaa_proxy()  {return msaa_child(0);}
+  virtual void msaa_on_focus();
+#endif // FL_HAVE_MSAA
 };
 
 /**
Index: FL/Fl_Menu_Bar.H
===================================================================
--- FL/Fl_Menu_Bar.H	(revision 6732)
+++ FL/Fl_Menu_Bar.H	(working copy)
@@ -80,6 +80,14 @@
   */
     Fl_Menu_Bar(int X, int Y, int W, int H,const char *l=0)
       : Fl_Menu_(X,Y,W,H,l) {}
+
+#ifdef FL_HAVE_MSAA
+  // MSAA support
+protected:
+  long msaa_role(long id);
+  bool msaa_menu_location(int pos, long id, long* X, long* Y, long* W, long* H);
+  bool msaa_menu_shortcut(int pos, long id, BSTR* bstr);
+#endif // FL_HAVE_MSAA
 };
 
 #endif
Index: FL/Fl_Choice.H
===================================================================
--- FL/Fl_Choice.H	(revision 6732)
+++ FL/Fl_Choice.H	(working copy)
@@ -99,6 +99,14 @@
   int value(int v);
 
   int value(const Fl_Menu_Item* v);
+
+#ifdef FL_HAVE_MSAA
+  // MSAA support
+protected:
+  bool msaa_value(long id, BSTR* bstr);
+  long msaa_role(long id);
+  bool msaa_put_value(long id, const char* str);
+#endif // FL_HAVE_MSAA
 };
 
 #endif
Index: FL/Fl_Browser.H
===================================================================
--- FL/Fl_Browser.H	(revision 6732)
+++ FL/Fl_Browser.H	(working copy)
@@ -309,6 +309,18 @@
   /** For back compatibility only. */
   void replace(int a, const char* b) { text(a, b); }
   void display(int line, int val=1);
+
+#ifdef FL_HAVE_MSAA
+  // MSAA support
+protected:
+  long msaa_browser_size();
+  bool msaa_browser_displayed(long id);
+  bool msaa_browser_selected(long id);
+  long msaa_browser_find_item(void* l);
+  long msaa_browser_focus();
+  void msaa_browser_set_focus(long id);
+  bool msaa_browser_text(long id, BSTR* bstr);
+#endif // FL_HAVE_MSAA
 };
 
 #endif
Index: FL/Fl_Valuator.H
===================================================================
--- FL/Fl_Valuator.H	(revision 6732)
+++ FL/Fl_Valuator.H	(working copy)
@@ -135,6 +135,15 @@
   double round(double); // round to nearest multiple of step
   double clamp(double); // keep in range
   double increment(double, int); // add n*step to value
+
+#ifdef FL_HAVE_MSAA
+  // MSAA support
+protected:
+  virtual void msaa_valuator_on_change();
+
+  bool msaa_value(long id, BSTR* bstr);
+  bool msaa_put_value(long id, const char* str);
+#endif // FL_HAVE_MSAA
 };
 
 #endif
Index: FL/Fl_Menu_.H
===================================================================
--- FL/Fl_Menu_.H	(revision 6732)
+++ FL/Fl_Menu_.H	(working copy)
@@ -36,6 +36,8 @@
 #endif
 #include "Fl_Menu_Item.H"
 
+class Fl_Menu_Proxy;
+
 /**
   Base class of all widgets that have a menu in FLTK.
   Currently FLTK provides you with 
@@ -137,6 +139,27 @@
   Fl_Color down_color() const {return selection_color();}
   /** For back compatibility, same as selection_color() */
   void down_color(unsigned c) {selection_color(c);}
+
+#ifdef FL_HAVE_MSAA
+  // MSAA support
+  friend class Fl_Menu_Proxy;
+
+private:
+  Fl_Menu_Proxy** msaa_menu_items_;
+  Fl_Menu_Proxy** msaa_menu_popups_;
+  void msaa_menu_clear();
+
+protected:
+  Fl_Msaa_Proxy* msaa_child(long id);
+  Fl_Menu_Proxy* msaa_menu_proxy(int pos, bool isPopup);
+
+  const Fl_Menu_Item* msaa_menu_get_item(int pos, long id);
+  int msaa_menu_parent(int pos);
+  int msaa_menu_child_id(int pos);
+  virtual bool msaa_menu_location(int pos, long id,
+    long* X, long* Y, long* W, long* H);
+  virtual bool msaa_menu_shortcut(int pos, long id, BSTR* bstr);
+#endif // FL_HAVE_MSAA
 };
 
 #endif
Index: FL/Fl_Msaa_Proxy.H
===================================================================
--- FL/Fl_Msaa_Proxy.H	(revision 0)
+++ FL/Fl_Msaa_Proxy.H	(revision 0)
@@ -0,0 +1,122 @@
+//
+// "$Id: $"
+//
+// WIN32 MSAA proxy header file for the Fast Light Tool Kit (FLTK).
+//
+// Copyright 2008 by Bill Spitzak and others.
+//
+// This library is free software; you can redistribute it and/or
+// modify it under the terms of the GNU Library General Public
+// License as published by the Free Software Foundation; either
+// version 2 of the License, or (at your option) any later version.
+//
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+// Library General Public License for more details.
+//
+// You should have received a copy of the GNU Library General Public
+// License along with this library; if not, write to the Free Software
+// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+// USA.
+//
+// Please report all bugs and problems on the following page:
+//
+//     http://www.fltk.org/str.php
+//
+
+#ifndef Fl_Msaa_Proxy_H
+#define Fl_Msaa_Proxy_H
+
+#include "Fl_Widget.H"
+
+#ifdef FL_HAVE_MSAA
+#  include <windows.h>
+#  include <oleacc.h>
+
+// MSAA proxy for Fl_Widget object
+class FL_EXPORT Fl_Msaa_Proxy : public IAccessible
+{
+private:
+  LONG           mRefCount;	// Reference counter
+  Fl_Msaa_Proxy* mpParent;	// Forced parent proxy
+
+public:
+  Fl_Widget* mpObj;		// Pointer to widget being represented
+
+  Fl_Msaa_Proxy(Fl_Widget* o) : mRefCount(0), mpParent(NULL), mpObj(o)  {}
+  virtual ~Fl_Msaa_Proxy();
+
+  void Detach()  {mpObj = NULL;}
+  void OverrideParent(Fl_Msaa_Proxy* parent);
+
+  virtual long LookupChild(Fl_Widget* o);
+
+  // IUnknown implementation
+  HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid, void**);
+  ULONG STDMETHODCALLTYPE AddRef();
+  ULONG STDMETHODCALLTYPE Release();
+
+  // IDispatch implementation
+  HRESULT STDMETHODCALLTYPE GetTypeInfoCount(UINT*);
+  HRESULT STDMETHODCALLTYPE GetTypeInfo(UINT, LCID, ITypeInfo**);
+  HRESULT STDMETHODCALLTYPE GetIDsOfNames(REFIID, LPOLESTR*,
+      UINT, LCID, DISPID*);
+  HRESULT STDMETHODCALLTYPE Invoke(DISPID, REFIID, LCID, WORD,
+      DISPPARAMS*, VARIANT*, EXCEPINFO*, UINT*);
+
+  // IAccessible implementation
+  HRESULT STDMETHODCALLTYPE get_accParent(IDispatch**);
+  HRESULT STDMETHODCALLTYPE get_accChildCount(long*);
+  HRESULT STDMETHODCALLTYPE get_accChild(VARIANT, IDispatch**);
+  HRESULT STDMETHODCALLTYPE get_accName(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE get_accValue(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE get_accDescription(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE get_accRole(VARIANT, VARIANT*);
+  HRESULT STDMETHODCALLTYPE get_accState(VARIANT, VARIANT*);
+  HRESULT STDMETHODCALLTYPE get_accHelp(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE get_accHelpTopic(BSTR*, VARIANT, long*);
+  HRESULT STDMETHODCALLTYPE get_accKeyboardShortcut(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE get_accFocus(VARIANT*);
+  HRESULT STDMETHODCALLTYPE get_accSelection(VARIANT*);
+  HRESULT STDMETHODCALLTYPE get_accDefaultAction(VARIANT, BSTR*);
+  HRESULT STDMETHODCALLTYPE accSelect(long, VARIANT);
+  HRESULT STDMETHODCALLTYPE accLocation(long*, long*, long*, long*, VARIANT);
+  HRESULT STDMETHODCALLTYPE accNavigate(long, VARIANT, VARIANT*);
+  HRESULT STDMETHODCALLTYPE accHitTest(long, long, VARIANT*);
+  HRESULT STDMETHODCALLTYPE accDoDefaultAction(VARIANT);
+  HRESULT STDMETHODCALLTYPE put_accName(VARIANT, BSTR);
+  HRESULT STDMETHODCALLTYPE put_accValue(VARIANT, BSTR);
+};
+
+// Utility functions for BSTR
+extern FL_EXPORT void fl_str_to_bstr(const char* str, int len, BSTR* bstr);
+extern FL_EXPORT char* fl_bstr_to_str(const BSTR bstr, size_t* pLen = 0);
+extern FL_EXPORT char* fl_label_to_text(const char* label, size_t* pLen = 0);
+extern FL_EXPORT char* fl_label_to_shortcut(const char* label, size_t* pLen = 0);
+extern FL_EXPORT void fl_free_str(char* str);
+
+// OLEACC.DLL symbols
+typedef LRESULT (WINAPI* flTypeLresultFromObject)(REFIID, WPARAM, LPUNKNOWN);
+extern FL_EXPORT flTypeLresultFromObject flLresultFromObject;
+typedef HRESULT (WINAPI* flTypeAccessibleObjectFromWindow)(
+    HWND, DWORD, REFIID, void**);
+extern FL_EXPORT flTypeAccessibleObjectFromWindow flAccessibleObjectFromWindow;
+
+// OLEAUT32.DLL symbols
+typedef HRESULT (WINAPI* flTypeVariantCopy)(LPVARIANTARG, LPVARIANTARG);
+extern FL_EXPORT flTypeVariantCopy flVariantCopy;
+typedef HRESULT (WINAPI* flTypeVariantClear)(LPVARIANTARG);
+extern FL_EXPORT flTypeVariantClear flVariantClear;
+typedef BSTR (WINAPI* flTypeSysAllocStringLen)(const OLECHAR*, unsigned int);
+extern FL_EXPORT flTypeSysAllocStringLen flSysAllocStringLen;
+typedef UINT (WINAPI* flTypeSysStringLen)(BSTR);
+extern FL_EXPORT flTypeSysStringLen flSysStringLen;
+
+#endif // FL_HAVE_MSAA
+
+#endif
+
+//
+// End of "$Id: $".
+//
Index: FL/Fl_Box.H
===================================================================
--- FL/Fl_Box.H	(revision 6732)
+++ FL/Fl_Box.H	(working copy)
@@ -60,6 +60,12 @@
 	: Fl_Widget(X,Y,W,H,l) {box(b);}
 
   virtual int handle(int);
+
+#ifdef FL_HAVE_MSAA
+protected:
+  // MSAA support
+  bool msaa_use_proxy()  {return false;}
+#endif // FL_HAVE_MSAA
 };
 
 #endif
Index: FL/Fl_Window.H
===================================================================
--- FL/Fl_Window.H	(revision 6732)
+++ FL/Fl_Window.H	(working copy)
@@ -364,6 +364,20 @@
   void default_cursor(Fl_Cursor, Fl_Color=FL_BLACK, Fl_Color=FL_WHITE);
   static void default_callback(Fl_Window*, void* v);
 
+#ifdef FL_HAVE_MSAA
+  // MSAA support
+private:
+  int msaa_caret_w_;
+  int msaa_caret_h_;
+
+protected:
+  const Fl_Window* msaa_window() const  {return this;}
+  long msaa_role(long id);
+  long msaa_state(long id);
+
+public:
+  void msaa_set_caret(int X, int Y, int W, int H) const;
+#endif // FL_HAVE_MSAA
 };
 
 #endif
Index: FL/Fl_Value_Input.H
===================================================================
--- FL/Fl_Value_Input.H	(revision 6732)
+++ FL/Fl_Value_Input.H	(working copy)
@@ -126,6 +126,12 @@
   /** Sets the color of the text cursor. The text cursor is black by default. */
   void cursor_color(unsigned n) {input.cursor_color(n);}
 
+#ifdef FL_HAVE_MSAA
+  // MSAA support
+protected:
+  long msaa_role(long id);
+  long msaa_state(long id);
+#endif // FL_HAVE_MSAA
 };
 
 #endif
Index: FL/Fl_Value_Output.H
===================================================================
--- FL/Fl_Value_Output.H	(revision 6732)
+++ FL/Fl_Value_Output.H	(working copy)
@@ -86,6 +86,12 @@
   Fl_Color textcolor() const {return (Fl_Color)textcolor_;}
   /**    Gets the color of the text in the value box.  */
   void textcolor(unsigned s) {textcolor_ = s;}
+
+#ifdef FL_HAVE_MSAA
+  // MSAA support
+protected:
+  long msaa_role(long id);
+#endif // FL_HAVE_MSAA
 };
 
 #endif
Index: FL/Fl_Scroll.H
===================================================================
--- FL/Fl_Scroll.H	(revision 6732)
+++ FL/Fl_Scroll.H	(working copy)
@@ -131,6 +131,32 @@
   int yposition() const {return yposition_;}
   void scroll_to(int, int);
   void clear();
+
+#ifdef FL_HAVE_MSAA
+  // MSAA support
+  friend class Fl_Msaa_Scroll_Proxy;
+
+private:
+  Fl_Msaa_Scroll_Proxy* msaa_scroll_proxy_;
+
+protected:
+  void msaa_cleanup();
+  long msaa_child_count()  {return children() - 2;}
+  bool msaa_parent(IDispatch** dispatch);
+  long msaa_role(long id);
+  bool msaa_location(long id, long* X, long* Y, long* W, long* H);
+
+  long msaa_scroll_size() const  {return 4;}
+  bool msaa_scroll_parent(IDispatch** dispatch);
+  Fl_Msaa_Proxy* msaa_scroll_child(long id);
+  void msaa_scroll_bbox(long* X, long* Y, long* W, long* H);
+  long msaa_scroll_role(long id);
+  long msaa_scroll_state(long id);
+  bool msaa_scroll_location(long id, long* X, long* Y, long* W, long* H);
+
+public:
+  Fl_Msaa_Proxy* msaa_proxy();
+#endif // FL_HAVE_MSAA
 };
 
 #endif
Index: FL/Fl_Input_.H
===================================================================
--- FL/Fl_Input_.H	(revision 6732)
+++ FL/Fl_Input_.H	(working copy)
@@ -265,6 +265,16 @@
   */
   void wrap(int b) { if (b) type((uchar)(type() | FL_INPUT_WRAP));
                          else type((uchar)(type() & ~FL_INPUT_WRAP)); }
+
+#ifdef FL_HAVE_MSAA
+  // MSAA support
+protected:
+  long msaa_role(long id);
+  bool msaa_value(long id, BSTR* bstr);
+  bool msaa_put_value(long id, const char* str);
+
+  virtual void msaa_input_on_change();
+#endif // FL_HAVE_MSAA
 };
 
 #endif 
Index: FL/Fl_Button.H
===================================================================
--- FL/Fl_Button.H	(revision 6732)
+++ FL/Fl_Button.H	(working copy)
@@ -167,6 +167,17 @@
 
   /// (for backwards compatibility)
   void down_color(unsigned c) {selection_color(c);}
+
+#ifdef FL_HAVE_MSAA
+  // MSAA support
+protected:
+  bool msaa_value(long id, BSTR* bstr);
+  long msaa_role(long id);
+  long msaa_state(long id);
+  bool msaa_action(long id, BSTR* bstr);
+  bool msaa_do_action(long id);
+  bool msaa_put_value(long id, const char* str);
+#endif // FL_HAVE_MSAA
 };
 
 #endif
Index: FL/Fl_Scrollbar.H
===================================================================
--- FL/Fl_Scrollbar.H	(revision 6732)
+++ FL/Fl_Scrollbar.H	(working copy)
@@ -111,6 +111,18 @@
   */
   void linesize(int i) {linesize_ = i;}
 
+#ifdef FL_HAVE_MSAA
+  // MSAA support
+protected:
+  void msaa_valuator_on_change();
+  long msaa_child_count()  {return 5;}
+  bool msaa_name(long id, BSTR* bstr);
+  long msaa_role(long id);
+  long msaa_state(long id);
+  bool msaa_action(long id, BSTR* bstr);
+  bool msaa_location(long id, long* x, long* y, long* w, long* h);
+  bool msaa_do_action(long id);
+#endif // FL_HAVE_MSAA
 };
 
 #endif
Index: FL/Fl_Menu_Button.H
===================================================================
--- FL/Fl_Menu_Button.H	(revision 6732)
+++ FL/Fl_Menu_Button.H	(working copy)
@@ -63,6 +63,13 @@
   int handle(int);
   const Fl_Menu_Item* popup();
   Fl_Menu_Button(int,int,int,int,const char * =0);
+
+#ifdef FL_HAVE_MSAA
+  // MSAA support
+protected:
+  long msaa_role(long id);
+  bool msaa_menu_location(int pos, long id, long* X, long* Y, long* W, long* H);
+#endif // FL_HAVE_MSAA
 };
 
 #endif
Index: fluid/Fl_Type.cxx
===================================================================
--- fluid/Fl_Type.cxx	(revision 6732)
+++ fluid/Fl_Type.cxx	(working copy)
@@ -188,6 +188,13 @@
   int handle(int);
   void callback();
   Widget_Browser(int,int,int,int,const char * =0);
+
+#ifdef FL_HAVE_MSAA
+  // MSAA support
+protected:
+  bool msaa_browser_text(long id, BSTR* bstr);
+  bool msaa_browser_description(long id, BSTR* bstr);
+#endif // FL_HAVE_MSAA
 };
 
 static Widget_Browser *widget_browser;
@@ -1012,6 +1020,100 @@
 }
 
 
+#ifdef FL_HAVE_MSAA
+#include <FL/Fl_Msaa_Proxy.H>
+///////////////////////////////////////////////////////////////////////
+//
+//  The following code implements Microsoft Active Accessibility
+
+bool
+Widget_Browser::msaa_browser_text(long id, BSTR* bstr)
+{
+  if (id < 1)  return false;
+  void* v;
+  for (v = item_first();  --id;  v = item_next(v));
+
+  // NOTE: String extraction must match algorithm in item_draw()
+  Fl_Type *l = (Fl_Type *)v;
+  if (l->is_widget() || l->is_class())
+  {
+    const char* subclass = subclassname(l);
+    if (!strncmp(subclass, "Fl_", 3))  subclass += 3;
+    size_t len = strlen(subclass);
+    const char* c = l->name();
+    if (c)
+    {
+      // Widget has a name
+      len += (strlen(c) + 2);
+      char* buf = (char*)malloc(len + 1);
+      sprintf(buf, "%s  %s", subclass, c);
+      fl_str_to_bstr(buf, len, bstr);
+      free(buf);
+    }
+    else if (c = l->label())
+    {
+      // Widget has a label
+      char* buf = (char*)malloc(len + 52);
+      sprintf(buf, "%s  ", subclass);
+      char* p = buf + len + 2;
+      *p++ = '"';
+      for (int i = 20; i--;) {
+        if (! (*c & -32)) break;
+        *p++ = *c++;
+      }
+      if (*c) {strcpy(p,"..."); p+=3;}
+      *p++ = '"';
+      fl_str_to_bstr(buf, p - buf, bstr);
+      free(buf);
+    }
+    else
+    {
+      // Only widget class is known
+      fl_str_to_bstr(subclass, len, bstr);
+    }
+    return true;
+  }
+  else
+  {
+    const char* c = l->title();
+    char buf[60]; char* p = buf;
+    for (int i = 55; i--;) {
+      if (! (*c & -32)) break;
+      *p++ = *c++;
+    }
+    if (*c) {strcpy(p,"..."); p+=3;}
+    *p = 0;
+    fl_str_to_bstr(buf, p - buf, bstr);
+  }
+  return true;
+}
+
+
+bool
+Widget_Browser::msaa_browser_description(long id, BSTR* bstr)
+{
+  if (!show_comments)  return false;
+
+  if (id < 1)  return false;
+  void* v;
+  for (v = item_first();  --id;  v = item_next(v));
+  Fl_Type *l = (Fl_Type *)v;
+
+  // NOTE: String extraction must match algorithm in item_draw()
+  const char *s = l->comment();
+  if (!s)  return false;
+  char buf[82], *d = buf;
+  for (int i=0; i<80; i++) {
+    char c = *s++;
+    if (c==0 || c=='\n') break;
+    *d++ = c;
+  }
+  *d = 0;
+  fl_str_to_bstr(buf, d - buf, bstr);
+  return true;
+}
+#endif // FL_HAVE_MSAA
+
 //
 // End of "$Id$".
 //
